#ifndef _KIT_MACRO_H_
#define _KIT_MACRO_H_
#ifdef __cplusplus
extern "C" {
#endif

#include <stddef.h>
#include <stdint.h>
#include <stdbool.h>

typedef enum
{
    kKitResult_Ok = 0x00,
    kKitResult_Error,
    kKitResult_Null,
    kKitResult_TimeOut,
    kKitResult_OutRange,
    
    kKitResult_NullPtr,
    kKitResult_ParamErr,
    kKitResult_CheckErr,
    kKitResult_OverFlow,
}KitResult;

#define USE_BIT_ARRAY           false

typedef void (* NoArgCall) (void);
typedef void (* VoidArgCall) (void *arg);
typedef void (* UintArgCall) (uint32_t arg);
typedef void (* KitIrqCall) (KitResult res, void *data);
typedef void (* UintCall) (KitResult res, uint32_t data);

#ifdef __cplusplus
}
#endif

#endif
